Subject: buffering with mpich

From: "Rodrigo Bisbal" <[email-masked]>
Date: Tue, 9 Jul 1996 14:52:29 -0400

MPI version : 1.0.12 (February 1, 1996)
Implementation : mpich
Uname -s    : IRIX extreme 5.3 08031226 IP22 mips
SGI hinv:
        1 200 MHZ IP22 Processor
        FPU: MIPS R4010 Floating Point Chip Revision: 0.0
        CPU: MIPS R4400 Processor Chip Revision: 6.0
        On-board serial ports: 2
        On-board bi-directional parallel port
        Data cache size: 16 Kbytes
        Instruction cache size: 16 Kbytes
        Secondary unified instruction/data cache size: 2 Mbytes
        Main memory size: 96 Mbytes
        EISA bus: adapter 0
        Integral Ethernet: ec0, version 1
        Integral SCSI controller 1: Version WD33C93B, revision D
        Integral SCSI controller 0: Version WD33C93B, revision D

PROBLEM:

I am pushing the limits of the buffer and message size for the
nonblocking buffered send. I need to send a lot of data and continue
computing in an overlapping fashion.

This is what I've done:

. I create a buffer of 500K and attach it:
  buffer=malloc(500000);
  MPI_Buffer_attach(500000);

. then I create a message of 50K bytes size
  message=malloc(50000);

. the receiver process won't start receiving until after 10 seconds
  allowing to test if the sender buffer works.

. then I start sending 10 messages, it fills up up to 100K (2 messages), even
though
  I attached a 500K buffer ??
  The rest of the messages are not delivered until the receiver
  starts receiving.

. I am using the MPI_Bsend and MPI_Ibsend calls.

I have concluded that these buffered calls are not using the
user specified buffer. They must be using a default MPI buffering
scheme.

QUESTIONS:

1. Is there a limit for the used-defined buffer size? (can it be more that
100K?)
2. Besides attaching a buffer, what else do you need to increase the buffer
size ?
3. Is there additional flags when calling MPI_Bsend and/or MPI_Ibsend to take
full
   advantage of the buffer ?
4. Any ideas, comments ?
5. Any experiences buffering within LAM or CHIMP? (I am using mpich)

ANY COMMENTS ARE APPRECIATED:
===================================
*  Rodrigo Bisbal                 *
*  Concurrent Technologies Corp.  *
*  [email-masked]                 *
===================================